#!/usr/bin/perl
system("clear");
print "Welcome to the NoobEvaluator instalation script\n";
print "Please give the absolute path to install (make sure you have appropiate permisions)\n";
print "Example: /home/username/noob.evaluator\n";
do {
	$install_path = <STDIN>;
	chop $install_path;
} until ( length($install_path) );
if ( $install_path =~ /\/$/ ) { #path contains a terminating slash 
	substr($install_path, length ($install_path) - 1, 1) = '';
}
if ( -d $install_path ) {
	print "The $install_path directory already exists.\n";
	print "Do you want to continue? [y/N]\n";
	$answer = <STDIN>;
	if ( $answer !~ /y|yes/i ) {
		print "Ok, exiting\n";
		exit 0;
	}
}
else { mkdir $install_path; }
#now we can start installing
$install_bad = 0;
if ( system("python -V 2> /dev/null") != 0 ) {
	print "It seems you don't have python installed.\n";
	$install_bad = 1;
}
if ( system("g++ -v 2> /dev/null") != 0 ) {
	print "It seems you don't have g++ installed.\n";
	$install_bad = 1;
}
if ( $install_bad ) {
	print "Exiting";
	exit 1;
}
#the triplets are 'source', 'build', 'destination for build'
@file_list = ( 	("src/comparer.cpp", "build/comparer", "./"), 
		("src/generator/generator.cpp", "build/generator", "./bruteforce/"),
		("src/generator/testmaker.cpp", "build/testmaker", "./bruteforce/"),
		("src/test.py", "test.py", "./"),
		("src/functions.py", "functions.py", "./"),
		("src/generator/gorilla.py", "start.py", "./bruteforce/") );
@dest_folder = ("bruteforce", "tests", "bruteforce/tests");
$compile = 1;
if ( -d "./build" ) {
	$incomplete_build = 0;
	for ($i = 0; $i < @file_list; $i += 3) {
		$source = @file_list[$i];
		$build = @file_list[$i + 1];
		if ( $source =~ /\.cpp$/ && (! -f $build) ) {
			$incomplete_build = 1;
			last;
		}
	}
	if ( ! $incomplete_build ) {
		print "It seems that all of the sources have been already built.\n";
		print "Do you want to recompile them?[Y/n]\n";
		$answer = <STDIN>;
		if ( $answer =~ /[n|no]/i ) { $compile = 0; }
	}
}
else {
	mkdir "./build";
}
if ( $compile ) {
	print "Building...\n";
	for ($i = 0; $i < @file_list; $i += 3) {
		$source = @file_list[$i];
		if ( $source !~ /\.cpp$/ ) { next; }
		$build = @file_list[$i + 1];
		$status = system("g++ -O2 -o $build $source");
		if ( $status ) {
			print "It would seem that an error has occoured when trying to compile $source.\n";
			print "You should look into it and try again. Exiting.\n";
			exit 1;
		}
	}
}
print "Installing...\n";
foreach $name (@dest_folder) {
	mkdir "$install_path/$name";
}
for ($i = 0; $i < @file_list; $i += 3) {
	$source = @file_list[$i];
	$build = @file_list[$i + 1];
	$dest = @file_list[$i + 2];
	if ( $source =~ /\.cpp/ ) {
		system("cp $build $install_path/$dest");
		#chmod 0764, "$install_path/$dest/$build"; #theese 2 lines don't work
	}
	else {
		system("cp $source $install_path/$dest/$build");
		#chmod 0764, "$install_path/$dest/$build";
	}
}
print "Ok, all done. Hope you like NoobEval.\nWritten by Eduard (contact omega2youall at yahoo dot com)\n";
print "To start, run 'test.py'\n".
print "You can also use the test generator 'start.py' located in 'bruteforce/', although it is stil very basic\n";
exit 0;













