#!/usr/bin/python
r"""
noob evaluator
==========================
It is specialy designed to evaluate sources for the OJI and ONI
(State Olympiad of Informatics and National Olympiad of Informatics,
respectively)

Written by: Eduard Nicodei
"""
import os, signal, time, sys, shutil, subprocess
from functions import *

#define variables: here we define all of our variables, as well as supply information about what the store
#(the default values are given)
start_test = 1 #the number of the first test
end_test = 10 #the number of the last test
name = '' #name of the application we want to test
time_limit = 1 #time limit for each test
score = 0 #our score (a corect test yelds +10 to the score)
bad_tests_list = [] #a list with all the tests that didn't succed
main_test_time_start = 0.0 #the time of which the evaluator started
main_test_time_end = 0.0 #the time that the evaluator stoped
test_result = '' #result of a test (WA, OK, TLE)
app_status = False #status of the application
app_time = 0.0 #the time that the application has runned
comp_status = 0 #compare status
number_of_tests = 0 #the total number of tests (equal to end_test - start_test + 1)
in_test_file_extension = '.in' #extension for the in file in the testing directory
ok_test_file_extension = '.ok' #extention for the ok file in the testing direcotry
verbose = 0 #verbose level, -1 == quiet, 0 == normal, 1 == verbose

#end define variables

print 'Welcome to NooB EvaL'
print

#0-status 1-name 2-start 3-end 4-time 5-.in 6-.ok 7-verbose
arg_not_supplied = []
variables, arg_not_supplied = arg_manage(sys.argv)
status, name, start_test, end_test, time_limit, in_test_file_extension, ok_test_file_extension, verbose = variables
if status: exit(1)

if arg_not_supplied[0] != '':
    print arg_not_supplied[0]
    exit(1)
if verbose == 1:
    for i in range(1, 6):
        sys.stdout.write(arg_not_supplied[i])


#the main program
main_test_time_start = time.time()

signal.signal(signal.SIGINT, sig_handler)
number_of_tests = end_test - start_test + 1

for current_test in range(start_test, end_test + 1):
    if verbose == 1: sys.stdout.write('Test number %d of %d: ' %(current_test, number_of_tests))
    if verbose == 0 and not (current_test % (number_of_tests / 10 + 1)):
        sys.stdout.write(str(current_test * 100 / number_of_tests) + '%')
        sys.stdout.write(' ')
    sys.stdout.flush()
    
    #store weather this test was a fail or not
    test_result = 'WA'
    
    #copy the files
    if copy_files('./tests/%(t)d-%(n)s' %{'n': name, 't': current_test}, name.lower(), in_test_file_extension, ok_test_file_extension): #verify if they were copied corectly
        sys.stdout.write('ERROR: Could not copy files "./tests/%(t)d-%(n)s" to current directory.\n' %{'n': name, 't': current_test})
        sys.stdout.write('Exiting...\n')
        exit(1)

    #call the aplication
    app_status, app_time = run_app(name.lower(), time_limit)
    if not app_status:
        
        #verify the files
        comp_status = os.spawnl(os.P_WAIT, './comparer', 'comparer' , name.lower() + '.out', name.lower() + '.ok')
        if not comp_status: #the files are identical
            if verbose == 1: sys.stdout.write('OK (%f)\n' %app_time)
            score += 10
            test_result = 'OK'
        elif comp_status == 2: #wrong number of arguments
            sys.stdout.write('ERROR: Wrong number of arguments given to \'comparer\'.\n')
            sys.stdout.write('Exiting...\n')
            remove_files(name)
            exit(1)
        elif comp_status == 3: #could not open files
            if verbose != -1:
                sys.stdout.write('WARNING: \'comparer\' could not open one, or both of the\n')
                sys.stdout.write('%s.out and %s.ok files\n' %(name.lower(), name))
                sys.stdout.write('Continuing with testing...\n')
            test_result = '.out or .ok open error'
        elif verbose == 1: sys.stdout.write('Wrong answer (%f)\n' %app_time)
    else:
        if verbose == 1: sys.stdout.write('Time Limit Exeded (%f)!\n' %app_time)
        test_result = 'TLE'

    #cleanup and process the results of good or bad test
    remove_files(name)
    if test_result != 'OK':
        bad_tests_list += [str(current_test) + ': ' + test_result]

main_test_time_end = time.time()

#now for some diagnostics
sys.stdout.flush()
if verbose == 1:
    print 'End of %d test series for %s' %(number_of_tests, name)
    print ''
elif verbose == 0:
    print '100%\n'
print 'The total score was %d out of %d which means that a '%(score, number_of_tests * 10) \
      + str(round(float(score) / number_of_tests * 10, 2)) + '% accuracy was achieved' #a double lined print
print 'The total time was %f seconds' %(main_test_time_end - main_test_time_start)
if verbose != -1:
    if (score < number_of_tests * 10):
        print 'Tests that didn\'t produce the wright answer:'
        for test in bad_tests_list:
            print test


        





